<template>
  <div
    class="flex-layout"
    :class="getRootClass"
    :style="getRootStyle"
    v-loading="loading"
    element-loading-text="拼命加载中"
    element-loading-spinner="el-icon-loading"
    element-loading-background="rgba(0, 0, 0, 0.2)"
  >
    <div class="flex-layout-header">
      <slot name="header"></slot>
    </div>
    <div class="flex-layout-body" :class="{ 'no-bg': noBg }">
      <slot></slot>
    </div>
    <div class="flex-layout-footer">
      <slot name="footer"></slot>
    </div>
  </div>
</template>

<script>
export default {
  props: {
    direction: {
      type: String,
      default: "",
    },
    height: {
      type: String,
      default: "100%",
    },
    noBg: {
      type: Boolean,
      default: false,
    },
    loading: {
      type: Boolean,
      default: false,
    },
  },
  computed: {
    getRootClass: function() {
      return {
        "direction-row": this.direction == "row" ? true : false,
      };
    },
    getRootStyle: function() {
      return {
        height: this.height,
      };
    },
  },
};
</script>

<style scoped>
.flex-layout {
  display: flex;
  flex-direction: column;
  height: 100%;
}
.flex-layout.direction-row {
  flex-direction: row;
}
.flex-layout.full-ht {
  height: 100%;
}

.flex-layout-body {
  flex: 1;
  overflow-x: hidden;
  overflow-y: auto;
}
.flex-layout-body.no-bg {
  background-color: #05227200;
}
</style>
